xfstests: add _require_freeze and minor cleanups
[xfstests-dev.git] / 068
1 #! /bin/bash
2 # FSQA Test No. 068
3 #
4 # Test case to reproduce xfs_freeze hang under filsystem load.
5 # The fail case for this test is a hang on an xfs_freeze.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2000-2005 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25 # creator
26 owner=ajones@sgi.com
27
28 seq=`basename $0`
29 echo "QA output created by $seq"
30
31 here=`pwd`
32 tmp=/tmp/$$
33 status=0        # success is the default!
34
35 ITERATIONS=10
36
37 _cleanup()
38 {
39     cd /
40     _cleanup_testdir
41
42     trap 0 1 2 3 15
43     exit $status
44 }
45
46 trap "_cleanup" 0 1 2 3 15
47
48
49 # get standard environment, filters and checks
50 . ./common.rc
51 . ./common.filter
52
53 # real QA test starts here
54 _supported_fs generic
55 _supported_os Linux IRIX
56
57 _require_scratch
58 _require_freeze
59
60 echo "*** init FS"
61
62 rm -f $seq.full
63 umount $SCRATCH_DEV >/dev/null 2>&1
64 echo "*** MKFS ***"                         >>$seq.full
65 echo ""                                     >>$seq.full
66 _scratch_mkfs                               >>$seq.full 2>&1 \
67     || _fail "mkfs failed"
68 _scratch_mount                              >>$seq.full 2>&1 \
69     || _fail "mount failed"
70
71 touch $tmp.running
72
73
74 # start fsstress loop in a background block
75 {
76     STRESS_DIR="$SCRATCH_MNT/fsstress_test_dir"
77     mkdir "$STRESS_DIR"
78
79     procs=2
80     nops=200
81     while [ -f "$tmp.running" ]
82       do
83       # We do both read & write IO - not only is this more realistic,
84       # but it also potentially tests atime updates
85       $FSSTRESS_PROG -d $STRESS_DIR -p $procs -n $nops $FSSTRESS_AVOID \
86           > /dev/null 2>&1
87     done
88
89     rm -r $STRESS_DIR/*
90     rmdir $STRESS_DIR
91 } &
92
93 i=0
94 let ITERATIONS=$ITERATIONS-1
95
96 echo | tee -a $seq.full
97 while [ $i -le $ITERATIONS ]
98 do
99         echo "*** iteration: $i" | tee -a $seq.full
100         echo "*** freezing \$SCRATCH_MNT" | tee -a $seq.full
101         xfs_freeze -f "$SCRATCH_MNT" | tee -a $seq.full
102         [ $? != 0 ] && echo xfs_freeze -f "$SCRATCH_MNT" failed | \
103             tee -a $seq.full
104         sleep 2
105
106         echo "*** thawing  \$SCRATCH_MNT" | tee -a $seq.full
107         xfs_freeze -u "$SCRATCH_MNT" | tee -a $seq.full
108         [ $? != 0 ] && echo xfs_freeze -u "$SCRATCH_MNT" failed | \
109             tee -a $seq.full
110         sleep 2
111
112         echo  | tee -a $seq.full
113         let i=$i+1
114 done
115
116 # stop fsstress iterations
117 rm $tmp.running
118
119 # wait for fsstresses to finish
120 wait
121
122 _check_scratch_fs
123
124 exit 1